; LCDtɖ0.5b065535܂ł10i,16i,2iŕ\
;
; File:        lcd1a.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00
;
; t\
;         0123456789abcdef
;   1s   00255   00FF
;   2s   0000000011111111

        #INCLUDE <p18f14k50.inc>
        #INCLUDE "lcd.inc"
        #INCLUDE "stdlib.inc"

        ; U(12MHz) NbN PLLL(*4)
        ; EHb`hbO^C} dvO݃[h
        CONFIG FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF

bank0       UDATA   ; ϐ̒` oN0
Tcount1     RES 1      ; wait
Tcount2     RES 1      ; wait
Tcount3     RES 1      ; wait
LCD_WRITE   RES 1      ; writef[^w
LCD_TEMP    RES 1
Temp1       RES 1      ; Tu[`p̕ϐ
ARG1        RES 1      ; Tu[`
BYTE2HEX_TEMP RES 1

DIV_A       RES 1 ; Z̔폜w@Tu[`R[㓚Ԃ
DIV_MOD     RES 1 ; Tu[`R[]肪Ԃ
DIV_B       RES 1 ; Z̏w
DIV_AL      RES 1
DIV_AH      RES 1
DIV_MODL    RES 1
DIV_MODH    RES 1
DIV_COUNT   RES 1

LCD_BUF     RES 32     ; 16*2̉tpobt@
ARGL        RES 1
ARGH        RES 1

        GLOBAL  LCD_WRITE,LCD_TEMP,ARG1,ARGL,ARGH
        GLOBAL  Temp1,BYTE2HEX_TEMP
        GLOBAL  DIV_A,DIV_MOD,DIV_B,DIV_AL,DIV_AH,DIV_MODL,DIV_MODH,DIV_COUNT
        GLOBAL  Tcount1,Tcount2,Tcount3

        CODE
        ORG 0
        goto   start    ;   Zbg

start
        clrf    ANSEL   ; RC3-RC0,RA4fW^̓obt@ɐݒ
        clrf    ANSELH  ; RB5-RB4,RC7-RC6fW^̓obt@ɐݒ
        clrf    SLRCON  ; PORTA,PORTB,PORTCX[[gWɐݒ
        clrf    TRISA   ; PORTASo͂ɐݒ
        movlw   0f0h
        movwf   TRISB   ; RB7-RB4͂ɐݒ
        clrf    TRISC   ; PORTCSo͂ɐݒ肷
        clrf    PORTC   ; PORTCS0ɂB

        rcall   lcd_init    ;   t

;   tpobt@󔒂ŃNA
        lfsr    FSR0,LCD_BUF
        movlw   32
        movwf   Temp1
        movlw   ' '
buf_clr
        movwf   POSTINC0
       	decfsz  Temp1
    	goto    buf_clr

        clrf    ARGL
        clrf    ARGH

loop_deg
;   10i̍쐬(ϊlARGH:ARGL)
        lfsr    FSR1,LCD_BUF
        rcall   word2deg

;   16i̍쐬(ϊlARGH:ARGL)
        lfsr    FSR1,LCD_BUF+8
        rcall   word2hex
;   2i̍쐬(ϊlARGH:ARGL)
        lfsr    FSR1,LCD_BUF+d'16'
        rcall   word2bin
;   obt@̓etɕ\
        lfsr    FSR1,LCD_BUF
        rcall   lcd_disp
;   16bit̃CNg
        incf    ARGL
        movlw   0
        addwfc  ARGH
;   0.5b̑ҋ@
        rcall   wait500
        bra     loop_deg

        goto    $           ;   gŖ[v

wait500                 ; 0.5bWait
        movlw   d'50'  ; 10ms*50=0.5s
        movwf   Tcount1
dloop1
        movlw   d'200'	; 50s*200=10ms
        movwf   Tcount2
dloop2                   ; t=(12+12*count3)/48MHz 50s
        movlw   d'199'
        movwf   Tcount3
        nop
dloop3
        decfsz  Tcount3
        goto    dloop3
        decfsz  Tcount2
        goto    dloop2
        decfsz  Tcount1
        goto    dloop1
        return

        END
